<?php
/*
 * This file is a temporary fix for https://core.trac.wordpress.org/ticket/16855
 * and http://core.trac.wordpress.org/ticket/16885#comment:13
 * Until this fix has been corrected in WordPress itself
 * I have not yet implemented all patches in this temporary fix thing
 */

/* -----------------------------------------------------------------------------
 * from wp-includes/http.php :
 * ------------------------------------------------------------------------------
 */

function &_wp_http_get_object_WPFAVICONS() {
	static $http;

	if ( is_null($http) )
	$http = new WP_Http_WPFAVICONS();

	return $http;
}

function wp_remote_request_WPFAVICONS($url, $args = array()) {
	$objFetchSite = _wp_http_get_object_WPFAVICONS();
	return $objFetchSite->request($url, $args);
}


/* -----------------------------------------------------------------------------
 * from wp-includes/class-http.php :
 * ------------------------------------------------------------------------------
 */


class WP_Http_WPFAVICONS {

	function __construct()
	{
		WP_Http_WPFAVICONS::_getTransport();
		WP_Http_WPFAVICONS::_postTransport();
	}

	function &_getTransport( $args = array() )
	{
		static $working_transport, $blocking_transport, $nonblocking_transport;
		if ( is_null($working_transport) )
		{
			if ( true === WP_Http_ExtHttp::test($args) )
			{
				$working_transport['exthttp'] = new WP_Http_ExtHttp();
				$blocking_transport[] = &$working_transport['exthttp'];
			}
			else if
			( true === WP_Http_Curl_WPFAVICONS::test($args) ) {
				$working_transport['curl'] = new WP_Http_Curl_WPFAVICONS();
				$blocking_transport[] = &$working_transport['curl'];
			}
			else if ( true === WP_Http_Streams::test($args) )
			{
				$working_transport['streams'] = new WP_Http_Streams();
				$blocking_transport[] = &$working_transport['streams'];
			}
			else if ( true === WP_Http_Fopen::test($args) )
			{
				$working_transport['fopen'] = new WP_Http_Fopen();
				$blocking_transport[] = &$working_transport['fopen'];
			}
			else if ( true === WP_Http_Fsockopen::test($args) )
			{
				$working_transport['fsockopen'] = new WP_Http_Fsockopen();
				$blocking_transport[] = &$working_transport['fsockopen'];
			}
			foreach ( array('curl', 'streams', 'fopen', 'fsockopen', 'exthttp') as $transport )
			{
				if ( isset($working_transport[$transport]) )
				{
					$nonblocking_transport[] = &$working_transport[$transport];
				}
			}
		}
		do_action( 'http_transport_get_debug', $working_transport
		, $blocking_transport, $nonblocking_transport );
		if ( isset($args['blocking']) && !$args['blocking'] )
		return $nonblocking_transport;
		else
		return $blocking_transport;
	}

	function &_postTransport( $args = array() )
	{
		static $working_transport, $blocking_transport, $nonblocking_transport;

		if ( is_null($working_transport) )
		{
			if ( true === WP_Http_ExtHttp::test($args) )
			{
				$working_transport['exthttp'] = new WP_Http_ExtHttp();
				$blocking_transport[] = &$working_transport['exthttp'];
			}
			else if ( true === WP_Http_Curl_WPFAVICONS::test($args) )
			{
				$working_transport['curl'] = new WP_Http_Curl_WPFAVICONS();
				$blocking_transport[] = &$working_transport['curl'];
			}
			else if ( true === WP_Http_Streams::test($args) ) {
				$working_transport['streams'] = new WP_Http_Streams();
				$blocking_transport[] = &$working_transport['streams'];
			}
			else if ( true === WP_Http_Fsockopen::test($args) ) {
				$working_transport['fsockopen'] = new WP_Http_Fsockopen();
				$blocking_transport[] = &$working_transport['fsockopen'];
			}
			foreach ( array('curl', 'streams', 'fsockopen', 'exthttp') as $transport )
			{
				if ( isset($working_transport[$transport]) )
				{
					$nonblocking_transport[] = &$working_transport[$transport];
				}
			}
		}
		do_action( 'http_transport_post_debug'
		, $working_transport, $blocking_transport, $nonblocking_transport );
		if ( isset($args['blocking']) && !$args['blocking'] )
		{
			return $nonblocking_transport;
		}
		else
		{
			return $blocking_transport;
		}
	}

	function request( $url, $args = array() ) {
		global $wp_version;

		$defaults = array(
			'method' => 'GET',
			'timeout' => apply_filters( 'http_request_timeout', 5),
			'redirection' => apply_filters( 'http_request_redirection_count', 5),
			'httpversion' => apply_filters( 'http_request_version', '1.0'),
			'user-agent' => apply_filters( 'http_headers_useragent', 'WordPress/' . $wp_version . '; ' . get_bloginfo( 'url' )  ),
			'blocking' => true,
			'headers' => array(),
			'cookies' => array(),
			'body' => null,
			'compress' => false,
			'decompress' => true,
			'sslverify' => true
		);

		$r = wp_parse_args( $args, $defaults );
		$r = apply_filters( 'http_request_args', $r, $url );

		// Allow plugins to short-circuit the request
		$pre = apply_filters( 'pre_http_request', false, $r, $url );
		if ( false !== $pre )
		return $pre;

		$arrURL = parse_url( $url );

		if ( empty( $url ) || empty( $arrURL['scheme'] ) )
		return new WP_Error('http_request_failed', __('A valid URL was not provided.'));

		if ( $this->block_request( $url ) )
		return new WP_Error( 'http_request_failed', __( 'User has blocked requests through HTTP.' ) );

		// Determine if this is a https call and pass that on to the transport functions
		// so that we can blacklist the transports that do not support ssl verification
		$r['ssl'] = $arrURL['scheme'] == 'https' || $arrURL['scheme'] == 'ssl';

		$homeURL = parse_url( get_bloginfo( 'url' ) );
		$r['local'] = $homeURL['host'] == $arrURL['host'] || 'localhost' == $arrURL['host'];
		unset( $homeURL );

		if ( is_null( $r['headers'] ) )
		$r['headers'] = array();

		if ( ! is_array( $r['headers'] ) ) {
			$processedHeaders = WP_Http_WPFAVICONS::processHeaders( $r['headers'] );
			$r['headers'] = $processedHeaders['headers'];
		}

		if ( isset( $r['headers']['User-Agent'] ) ) {
			$r['user-agent'] = $r['headers']['User-Agent'];
			unset( $r['headers']['User-Agent'] );
		}

		if ( isset( $r['headers']['user-agent'] ) ) {
			$r['user-agent'] = $r['headers']['user-agent'];
			unset( $r['headers']['user-agent'] );
		}

		// Construct Cookie: header if any cookies are set
		WP_Http::buildCookieHeader( $r );

		if ( WP_Http_Encoding::is_available() )
		$r['headers']['Accept-Encoding'] = WP_Http_Encoding::accept_encoding();

		if ( empty($r['body']) ) {
			$r['body'] = null;
			// Some servers fail when sending content without the content-length header being set.
			// Also, to fix another bug, we only send when doing POST and PUT and the content-length
			// header isn't already set.
			if ( ($r['method'] == 'POST' || $r['method'] == 'PUT') && ! isset( $r['headers']['Content-Length'] ) )
			$r['headers']['Content-Length'] = 0;

			// The method is ambiguous, because we aren't talking about HTTP methods, the "get" in
			// this case is simply that we aren't sending any bodies and to get the transports that
			// don't support sending bodies along with those which do.
			$transports = WP_Http_WPFAVICONS::_getTransport( $r );
		}
		else
		{
			if ( is_array( $r['body'] ) || is_object( $r['body'] ) )
			{
				if ( ! version_compare(phpversion(), '5.1.2', '>=') )
				{
					$r['body'] = _http_build_query( $r['body'], null, '&' );
				}
				else
				{
					$r['body'] = http_build_query( $r['body'], null, '&' );
				}
				$r['headers']['Content-Type'] = 'application/x-www-form-urlencoded; charset='
				. get_option( 'blog_charset' );
				$r['headers']['Content-Length'] = strlen( $r['body'] );
			}

			if ( ! isset( $r['headers']['Content-Length'] )
				&& ! isset( $r['headers']['content-length'] ) )
			{
				$r['headers']['Content-Length'] = strlen( $r['body'] );
			}

			// The method is ambiguous, because we aren't talking about HTTP methods, the "post" in
			// this case is simply that we are sending HTTP body and to get the transports that do
			// support sending the body. Not all do, depending on the limitations of the PHP core
			// limitations.
			$transports = WP_Http_WPFAVICONS::_postTransport( $r );
		}

		do_action( 'http_api_debug', $transports, 'transports_list' );

		$response = array( 'headers' => array(), 'body' => ''
		, 'response' => array('code' => false, 'message' => false), 'cookies' => array() );
		foreach ( (array) $transports as $transport ) {
			$response = $transport->request( $url, $r );

			do_action( 'http_api_debug', $response, 'response', get_class( $transport ) );

			if ( ! is_wp_error( $response ) )
			return apply_filters( 'http_response', $response, $r, $url );
		}

		return $response;
	}

	function post($url, $args = array())
	{
		$defaults = array('method' => 'POST');
		$r = wp_parse_args( $args, $defaults );
		return $this->request($url, $r);
	}

	function get($url, $args = array())
	{
		$defaults = array('method' => 'GET');
		$r = wp_parse_args( $args, $defaults );
		return $this->request($url, $r);
	}

	function head($url, $args = array())
	{
		$defaults = array('method' => 'HEAD');
		$r = wp_parse_args( $args, $defaults );
		return $this->request($url, $r);
	}

	function processResponse($strResponse)
	{
		$res = explode("\r\n\r\n", $strResponse, 2);

		return array('headers' => isset($res[0]) ? $res[0] : array()
		, 'body' => isset($res[1]) ? $res[1] : '');
	}

	function processHeaders($headers)
	{


		// split headers, one per array element
		if ( is_string($headers) )
		{
			// tolerate line terminator: CRLF = LF (RFC 2616 19.3)
			$headers = str_replace("\r\n", "\n", $headers);
			// unfold folded header fields. LWS = [CRLF] 1*( SP | HT ) <US-ASCII SP, space (32)>, <US-ASCII HT, horizontal-tab (9)> (RFC 2616 2.2)
			$headers = preg_replace('/\n[ \t]/', ' ', $headers);
			// create the headers array
			$headers = explode("\n", $headers);
		}



		$response = array('code' => 0, 'message' => '');

		// If a redirection has taken place, The headers for each page request may have been passed.
		// In this case, determine the final HTTP header and parse from there.
		for ( $i = count($headers)-1; $i >= 0; $i-- )
		{
			if ( !empty($headers[$i]) && false === strpos($headers[$i], ':') )
			{
				$headers = array_splice($headers, $i);
				break;
			}
		}

		$cookies = array();
		$newheaders = array();
		foreach ( $headers as $tempheader )
		{
			if ( empty($tempheader) )
			{
				continue;
			}

			//if ( false === strpos($tempheader, ':') )
			//{
			//	list( , $response['code'], $response['message']) = explode(' ', $tempheader, 3);
			//	continue;
			//}

			# patch http://core.trac.wordpress.org/ticket/16885#comment:13
if ( false === strpos($tempheader, ':') ) {
$p = explode(' ', $tempheader, 3);
array_shift($p);
$response['code'] = array_shift($p);
$response['message'] = array_shift($p);
continue;
}

			list($key, $value) = explode(':', $tempheader, 2);

			if ( !empty( $value ) )
			{
				$key = strtolower( $key );
				if ( isset( $newheaders[$key] ) )
				{
					if ( !is_array($newheaders[$key]) )
					$newheaders[$key] = array($newheaders[$key]);
					$newheaders[$key][] = trim( $value );
				}
				else
				{
					$newheaders[$key] = trim( $value );
				}
				if ( 'set-cookie' == $key )
				{
					$cookies[] = new WP_Http_Cookie( $value );
				}
			}
		}

		return array('response' => $response, 'headers' => $newheaders, 'cookies' => $cookies);
	}

	function buildCookieHeader( &$r )
	{
		if ( ! empty($r['cookies']) )
		{
			$cookies_header = '';
			foreach ( (array) $r['cookies'] as $cookie )
			{
				$cookies_header .= $cookie->getHeaderValue() . '; ';
			}
			$cookies_header = substr( $cookies_header, 0, -2 );
			$r['headers']['cookie'] = $cookies_header;
		}
	}

	function chunkTransferDecode($body)
	{
		$body = str_replace(array("\r\n", "\r"), "\n", $body);
		// The body is not chunked encoding or is malformed.
		if ( ! preg_match( '/^[0-9a-f]+(\s|\n)+/mi', trim($body) ) )
		{
			return $body;
		}

		$parsedBody = '';
		//$parsedHeaders = array(); Unsupported

		while ( true )
		{
			$hasChunk = (bool) preg_match( '/^([0-9a-f]+)(\s|\n)+/mi', $body, $match );

			if ( $hasChunk )
			{
				if ( empty( $match[1] ) )
				return $body;

				$length = hexdec( $match[1] );
				$chunkLength = strlen( $match[0] );

				$strBody = substr($body, $chunkLength, $length);
				$parsedBody .= $strBody;

				$body = ltrim(str_replace(array($match[0], $strBody), '', $body), "\n");

				if ( "0" == trim($body) )
				return $parsedBody; // Ignore footer headers.
			}
			else
			{
				return $body;
			}
		}
	}

	function block_request($uri)
	{
		// We don't need to block requests, because nothing is blocked.
		if ( ! defined( 'WP_HTTP_BLOCK_EXTERNAL' ) || ! WP_HTTP_BLOCK_EXTERNAL )
		return false;

		// parse_url() only handles http, https type URLs, and will emit E_WARNING on failure.
		// This will be displayed on blogs, which is not reasonable.
		$check = @parse_url($uri);

		/* Malformed URL, can not process, but this could mean ssl, so let through anyway.
		 *
		 * This isn't very security sound. There are instances where a hacker might attempt
		 * to bypass the proxy and this check. However, the reason for this behavior is that
		 * WordPress does not do any checking currently for non-proxy requests, so it is keeps with
		 * the default unsecure nature of the HTTP request.
		 */
		if ( $check === false )
		return false;

		$home = parse_url( get_option('siteurl') );

		// Don't block requests back to ourselves by default
		if ( $check['host'] == 'localhost' || $check['host'] == $home['host'] )
		return apply_filters('block_local_requests', false);

		if ( !defined('WP_ACCESSIBLE_HOSTS') )
		return true;

		static $accessible_hosts;
		static $wildcard_regex = false;
		if ( null == $accessible_hosts ) {
			$accessible_hosts = preg_split('|,\s*|', WP_ACCESSIBLE_HOSTS);

			if ( false !== strpos(WP_ACCESSIBLE_HOSTS, '*') ) {
				$wildcard_regex = array();
				foreach ( $accessible_hosts as $host )
				$wildcard_regex[] = str_replace('\*', '[\w.]+?', preg_quote($host, '/'));
				$wildcard_regex = '/^(' . implode('|', $wildcard_regex) . ')$/i';
			}
		}

		if ( !empty($wildcard_regex) )
		return !preg_match($wildcard_regex, $check['host']);
		else
		return !in_array( $check['host'], $accessible_hosts ); //Inverse logic, If its in the array, then we can't access it.
	}
}

class WP_Http_Curl_WPFAVICONS {

	function request($url, $args = array())
	{
		$defaults = array(
			'method' => 'GET', 'timeout' => 5,
			'redirection' => 5, 'httpversion' => '1.0',
			'blocking' => true,
			'headers' => array(), 'body' => null, 'cookies' => array()
		);

		$r = wp_parse_args( $args, $defaults );

		if ( isset($r['headers']['User-Agent']) ) {
			$r['user-agent'] = $r['headers']['User-Agent'];
			unset($r['headers']['User-Agent']);
		} else if ( isset($r['headers']['user-agent']) ) {
			$r['user-agent'] = $r['headers']['user-agent'];
			unset($r['headers']['user-agent']);
		}

		// Construct Cookie: header if any cookies are set.
		WP_Http_WPFAVICONS::buildCookieHeader( $r );

		/* here it starts*/
		$handle = curl_init();

		// cURL offers really easy proxy support.
		$proxy = new WP_HTTP_Proxy();
		if ( $proxy->is_enabled() && $proxy->send_through_proxy( $url ) ) {
			$isPHP5 = version_compare(PHP_VERSION, '5.0.0', '>=');
			if ( $isPHP5 ) {
				curl_setopt( $handle, CURLOPT_PROXYTYPE, CURLPROXY_HTTP );
				curl_setopt( $handle, CURLOPT_PROXY, $proxy->host() );
				curl_setopt( $handle, CURLOPT_PROXYPORT, $proxy->port() );
			} else {
				curl_setopt( $handle, CURLOPT_PROXY, $proxy->host() .':'. $proxy->port() );
			}
			if ( $proxy->use_authentication() ) {
				if ( $isPHP5 )
				curl_setopt( $handle, CURLOPT_PROXYAUTH, CURLAUTH_ANY );

				curl_setopt( $handle, CURLOPT_PROXYUSERPWD, $proxy->authentication() );
			}
		}

		$is_local = isset($args['local']) && $args['local'];
		$ssl_verify = isset($args['sslverify']) && $args['sslverify'];
		if ( $is_local )
		$ssl_verify = apply_filters('https_local_ssl_verify', $ssl_verify);
		elseif ( ! $is_local )
		$ssl_verify = apply_filters('https_ssl_verify', $ssl_verify);


		// CURLOPT_TIMEOUT and CURLOPT_CONNECTTIMEOUT expect integers.  Have to use ceil since
		// a value of 0 will allow an ulimited timeout.
		$timeout = (int) ceil( $r['timeout'] );
		curl_setopt( $handle, CURLOPT_CONNECTTIMEOUT, $timeout );
		curl_setopt( $handle, CURLOPT_TIMEOUT, $timeout );
		curl_setopt( $handle, CURLOPT_URL, $url);
		curl_setopt( $handle, CURLOPT_RETURNTRANSFER, true );
		curl_setopt( $handle, CURLOPT_SSL_VERIFYHOST, $ssl_verify );
		curl_setopt( $handle, CURLOPT_SSL_VERIFYPEER, $ssl_verify );
		curl_setopt( $handle, CURLOPT_USERAGENT, $r['user-agent'] );
		curl_setopt( $handle, CURLOPT_MAXREDIRS, $r['redirection'] );

		switch ( $r['method'] ) {
			case 'HEAD':
				curl_setopt( $handle, CURLOPT_NOBODY, true );
				break;
			case 'POST':
				curl_setopt( $handle, CURLOPT_POST, true );
				curl_setopt( $handle, CURLOPT_POSTFIELDS, $r['body'] );
				break;
			case 'PUT':
				curl_setopt( $handle, CURLOPT_CUSTOMREQUEST, 'PUT' );
				curl_setopt( $handle, CURLOPT_POSTFIELDS, $r['body'] );
				break;
		}

		if ( true === $r['blocking'] )
		curl_setopt( $handle, CURLOPT_HEADER, true );
		else
		curl_setopt( $handle, CURLOPT_HEADER, false );

		// The option doesn't work with safe mode or when open_basedir is set.
		// Disable HEAD when making HEAD requests.
		if ( !ini_get('safe_mode') && !ini_get('open_basedir') && 'HEAD' != $r['method'] )
		curl_setopt( $handle, CURLOPT_FOLLOWLOCATION, true );

		if ( !empty( $r['headers'] ) ) {
			// cURL expects full header strings in each element
			$headers = array();
			foreach ( $r['headers'] as $name => $value ) {
				$headers[] = "{$name}: $value";
			}
			curl_setopt( $handle, CURLOPT_HTTPHEADER, $headers );
		}

		if ( $r['httpversion'] == '1.0' )
		curl_setopt( $handle, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_0 );
		else
		curl_setopt( $handle, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1 );

		// Cookies are not handled by the HTTP API currently. Allow for plugin authors to handle it
		// themselves... Although, it is somewhat pointless without some reference.
		do_action_ref_array( 'http_api_curl', array(&$handle) );

		// We don't need to return the body, so don't. Just execute request and return.
		if ( ! $r['blocking'] ) {
			curl_exec( $handle );
			curl_close( $handle );
			return array( 'headers' => array(), 'body' => '', 'response' => array('code' => false, 'message' => false), 'cookies' => array() );
		}

		$theResponse = curl_exec( $handle );

		//echo $theResponse;
		//print_r ($theResponse);

		if ( !empty($theResponse) )
		{
			$headerLength = curl_getinfo($handle, CURLINFO_HEADER_SIZE);
			$theHeaders = trim( substr($theResponse, 0, $headerLength) );
			if ( strlen($theResponse) > $headerLength )
			{
				$theBody = substr( $theResponse, $headerLength );
			}
			else
			{
				$theBody = '';
			}
			if ( false !== strpos($theHeaders, "\r\n\r\n") )
			{
				$headerParts = explode("\r\n\r\n", $theHeaders);
				$theHeaders = $headerParts[ count($headerParts) -1 ];
			}
			$theHeaders = WP_Http_WPFAVICONS::processHeaders($theHeaders);
		}
		else
		{
			if ( $curl_error = curl_error($handle) )
			{
				return new WP_Error('http_request_failed', $curl_error);
			}
			if ( in_array( curl_getinfo( $handle, CURLINFO_HTTP_CODE ), array(301, 302) ) )
			{
				return new WP_Error('http_request_failed', __('Too many redirects.'));
			}

			$theHeaders = array( 'headers' => array(), 'cookies' => array() );
			$theBody = '';
		}

		$response = array();
		$response['code'] = curl_getinfo( $handle, CURLINFO_HTTP_CODE );
		$response['message'] = get_status_header_desc($response['code']);

		/* EDL: I added this action here because I want this log information */
		do_action( 'http_api_curl_info', $handle);
		curl_close( $handle );

		// See #11305 - When running under safe mode, redirection is disabled above. Handle it manually.
		// EDL: We never want to step in this loop
		if ( $r['redirection'] > 0 && !empty($theHeaders['headers']['location']) && (ini_get('safe_mode')
			|| ini_get('open_basedir')) )
		{
			if ( $r['redirection']-- > 0 )
			{
				return $this->request($theHeaders['headers']['location'], $r);
			}
			else
			{
				return new WP_Error('http_request_failed', __('Too many redirects.'));
			}
		}

		if ( true === $r['decompress'] && true ===
		WP_Http_Encoding::should_decode($theHeaders['headers']) )
		$theBody = WP_Http_Encoding::decompress( $theBody );

		return array('headers' => $theHeaders['headers'],
		'body' => $theBody, 'response' => $response, 'cookies' => $theHeaders['cookies']);
	}

	/**
	 * Whether this class can be used for retrieving an URL.
	 *
	 * @static
	 * @since 2.7.0
	 *
	 * @return boolean False means this class can not be used, true means it can.
	 */
	function test($args = array()) {
		if ( function_exists('curl_init') && function_exists('curl_exec') )
		return apply_filters('use_curl_transport', true, $args);

		return false;
	}
}